library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity Q3 is
	 port(
	 	 CLK : in STD_LOGIC;
	 	 B1,B2 : in STD_LOGIC;
		 R,J : out STD_LOGIC
	     );
end Q3;
							 
architecture arch_Q3 of Q3 is	 

type StateMachine is (a,b,c,d,e);
signal state : StateMachine;

begin
	process(CLK)
	begin
	  if rising_edge(CLK) then -- rising_edge(CLK) = CLK'event and CLK='1'
		case state is
			when a => case B1&B2 is -- on concatne B1 et B2
					when "00" => state <= a;R <= '0';J <= '0';
					when "01" => state <= c;R <= '0';J <= '1';
					when "10" => state <= b;R <= '1';J <= '0';
					when "11" => state <= a;R <= '0';J <= '0';
					when others => state <= a;R <= '0';J <= '0';
				    end case;
			when b => case B1&B2 is -- on concatne B1 et B2
					when "00" => state <= a;R <= '0';J <= '0';
					when "01" => state <= d;R <= '1';J <= '1';
					when "10" => state <= a;R <= '0';J <= '0';
					when "11" => state <= d;R <= '1';J <= '1';
					when others => state <= a;R <= '0';J <= '0';
				    end case;
			when c => case B1&B2 is -- on concatne B1 et B2
					when "00" => state <= a;R <= '0';J <= '0';
					when "01" => state <= a;R <= '0';J <= '0';
					when "10" => state <= e;R <= '1';J <= '1';
					when "11" => state <= e;R <= '1';J <= '1';
					when others => state <= a;R <= '0';J <= '0';
				    end case;
			when d => case B1&B2 is -- on concatne B1 et B2
					when "00" => state <= e;R <= '0';J <= '1';
					when "01" => state <= e;R <= '0';J <= '1';
					when "10" => state <= e;R <= '0';J <= '1';
					when "11" => state <= a;R <= '0';J <= '0';
					when others => state <= a;R <= '0';J <= '0';
				    end case;					  
			when e => case B1&B2 is -- on concatne B1 et B2
					when "00" => state <= d;R <= '1';J <= '0';
					when "01" => state <= d;R <= '1';J <= '0';
					when "10" => state <= d;R <= '1';J <= '0';
					when "11" => state <= a;R <= '0';J <= '0';
					when others => state <= a;R <= '0';J <= '0';
				    end case;
		end case;
	  end if;
	end process; 
														  										 
end arch_Q3;

